require("defines")

Lockedvalues = {														-- some pre-set values for when there are multiple or no recipies, in combination with the values that I set for balancing.
["iron-ore"] = 1,
["iron-plate"] = 1,														-- plate value is the same as ore value to dis-allow farming EMC by transforming plate into a normally less-worth ore and creating new more-worth plates with that
["copper-ore"] = 1,
["copper-plate"] = 1,
["water"] = 1,
["crude-oil"] = 3,														-- THIS IS NOT GOOD, ONLY USE THESE OIL VALUES FOR TESTING AND UNTIL I FIND A BETTER WAY OF MANAGING IT, LIKE WITH CHECKING WHAT IS BEING USED 
["light-oil"] = 1,
["heavy-oil"] = 1,
["petroleum-gas"] = 1,
["raw-wood"] = 1,
["stone"] = 1

}

script.on_init(function ()

global.EE2Table = {}
global.EMC_table = Lockedvalues											-- test this

end)

script.on_load(function()

	if not global.EE2Table then global.EE2Table = {} end
	global.EMC_table = Lockedvalues

end)

function Add_To_Table(entity)											-- adds all the entities to the table together with the two functions below

	table.insert(global.EE2Table, entity)
	
	local To_write = ""													-- empty the string to build
	To_write = "Tick: " .. game.tick .. ": Entity has been placed in the table. Name: " .. entity.name .. ", coördinates:(X, Y, SN, SID) " .. entity.position.x .. ", " .. entity.position.y .. ", " .. entity.surface.name .. ", " .. entity.surface.index .. ", force: " .. entity.force.name .. "\n"
																		-- above, add all the neccesary/useable data to the string
	game.write_file("EE2/Bug.txt", To_write, true)						-- write a file in the script-output/EE2 directory called Bug.txt, the string to write is build just above, called "To_write, and if the file already exists, appends the file"
end


script.on_event(defines.events.on_built_entity, function(event)			-- to add entities build by players
	if event.created_entity.name == "energy-condenser" then
		Add_To_Table(event.created_entity)
	end
end)

script.on_event(defines.events.on_robot_built_entity, function(event)	-- to add entities build with robots
	if event.created_entity.name == "energy-condenser" then
		Add_To_Table(evet.created_entity)
	end
end)

function Did_Not_exist(entity)											-- used to tell people that they should file a bug report and tell them what they can do to fix the problem

	local To_write = ""													-- empty the string to build
	To_write = "Tick: " .. game.tick .. ": Entity was not in table. Name: " .. entity.name .. ", coördinates:(X, Y, SN, SID) " .. entity.position.x .. ", " .. entity.position.y .. ", " .. entity.surface.name .. ", " .. entity.surface.index .. ", force: " .. entity.force.name .. "\n"
																		-- above, add all the neccesary/useable data to the string
	game.write_file("EE2/Bug.txt", To_write, true)						-- write a file in the script-output/EE2 directory called Bug.txt, the string to write is build just above, called "To_write, and if the file already exists, appends the file"

end

function Did_Exist(entity)												-- only here for debugging and testing reasons

	local To_write = ""
	To_write = "Tick: " .. game.tick .. ": Entity was in table and has been deleted. Name: " .. entity.name .. ", coördinates:(X, Y, SN, SID) " .. entity.position.x .. ", " .. entity.position.y .. ", " .. entity.surface.name .. ", " .. entity.surface.index .. ", force: " .. entity.force.name .. "\n"
																		-- above, add all the neccesary/useable data to the string
	game.write_file("EE2/Bug.txt", To_write, true)						-- write a file in the script-output/EE2 directory called Bug.txt, the string to write is build just above, called "To_write, and if the file already exists, appends the file"
end

function Delete_From_Table(entity)										-- removes the entities from the table together with the three functions below

	for i,v in ipairs(global.EE2Table) do
	
		if v == entity then
		
			table.remove(global.EE2Table, i)
			
			return "succes"
		
		end

	end

	return "failed"														-- to tell people to file a bug report cause this should never happen

end

script.on_event(defines.events.on_entity_died, function(event)			-- to delete the deleted entity from the table
	if event.entity.name == "energy-condenser" then
		local var1 = Delete_From_Table(event.entity)

		if var1 == "failed" then

			Did_Not_exist(event.entity)
		
		elseif var1 == "succes" then
			
			Did_Exist(event.entity)
			
		end
	end
end)

script.on_event(defines.events.on_preplayer_mined_item, function(event)	-- to delete the deleted entity from the table
	if event.entity.name == "energy-condenser" then
		local var1 = Delete_From_Table(event.entity)

		if var1 == "failed" then

			Did_Not_exist(event.entity)
		
		elseif var1 == "succes" then
			
			Did_Exist(event.entity)
			
		end
	end
end)

script.on_event(defines.events.on_robot_pre_mined, function(event)		-- to delete the deleted entity from the table
	if event.entity.name == "energy-condenser" then
		local var1 = Delete_From_Table(event.entity)

		if var1 == "failed" then

			Did_Not_exist(event.entity)
		
		elseif var1 == "succes" then
			
			Did_Exist(event.entity)
			
		end
	end
end)

function Get_necessities(item, force)										-- fuction to search the recipe by an item-protype
	for _, recipe in pairs(force.recipes) do
		for _, product in pairs(recipe.products) do
			if product.name == item then
				return recipe.ingredients
			end
		end
	end
end

function Get_EMC_table_one(item, force)											-- rethink, this is not really working out

	necessities = {}															-- the table in which the calculating is going to be done
	
	EMC_count = 0																-- set the amount to count to zero

	table.insert(necessities, Get_necessities(item, force))						-- place a table of the neccesities of the recipe in the neccesities table
	
	game.players[1].print(tostring(Iterate_EMC_table(necessities, force)))		-- run second part of the calculation AND FOR TESTING PRINT IT

end

function Iterate_EMC_table(necessities, force)

	for i, v in ipairs(necessities) do
	
		if global.EMC_table[v.name] then											-- this deletes all the known items from the calculation speeding up calculation time
		
			EMC_count = EMC_count + (global.EMC_table[v.name] * v.amount)
			table.remove(necessities, v)										-- actually remove the piece from the table
		
			game.player.print(game.tick)										-- for testing
		
		end
	
	
	end
	
	To_write = tostring(EMC_count) .. "\n"

	game.write_file("EE2/Bug.txt", To_write, true)

	for i, v in ipairs(necessities) do
	
		To_add = Get_necessities(v.name, force)
		
		table.remove(necessities, i)
		
		game.players[1].print(necessities[i].name)
		
			for x, w in ipairs(To_add) do
				
				table.insert(necessities, w)
			
			end
	
	end

	if necessities[1] then
	
		Iterate_EMC_table(necessities, force)
	
	else
	
		return EMC_count
	
	end


end

remote.add_interface("test",
                     {hello = function() var2 = "wooden-chest"; Get_EMC_table_one(var2, game.players[1].force) end})



--[[function get_recipe(players, item)

	for _, recipe in pairs(players.force.recipes) do

		for _, product in pairs(recipe.products) do

			if (product.name == item) then

				if recipe.ingredients[1] ~= nil then
					TEXP_var_amountingred = 1
				end
				if recipe.ingredients[2] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[3] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[4] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[5] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[6] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[7] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[8] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[9] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end
				if recipe.ingredients[10] ~= nil then
					TEXP_var_amountingred = TEXP_var_amountingred + 1
				end

				return TEXP_var_amountingred

			end

		end

	end

	return nil
end--]]